/*
  OLED graph test

  This example shows how to display a graph from a analog input on a 128x64 px i2c oled display.

  A0 is connected to a Groove GSR sensor.

  Sources:
  http://wiki.seeedstudio.com/Grove-GSR_Sensor/
  https://www.how2electronics.com/pulse-sensor-with-oled-arduino/

  by Anne Vlaanderen 2019
*/


#include <Adafruit_SSD1306.h>
#define OLED_Address 0x3C        // 0x3C device address of I2C OLED. Few other OLED has 0x3D
Adafruit_SSD1306 oled(128, 64);  // create our screen object setting resolution to 128x64

int a=0;
int lasta=0;
int lastb=0;
int LastTime=0;
int ThisTime;
bool GSRTiming=false;
int GSR=0;
#define UpperThreshold 560
#define LowerThreshold 530

void setup() {
  oled.begin(SSD1306_SWITCHCAPVCC, OLED_Address);
  oled.clearDisplay();
  oled.setTextSize(1.6);
}


void loop() 
{
  if(a>127)               //width of display
  {
    oled.clearDisplay();
    a=0;
    lasta=a;
  }

  ThisTime=millis();
  int value=analogRead(0);
  oled.setTextColor(WHITE);
  int b=50-(value/16);    //height of display
  oled.writeLine(lasta,lastb,a,b,WHITE);
  lastb=b;
  lasta=a;
 
    
  oled.writeFillRect(0,50,128,16,BLACK);
  oled.setCursor(0,50);
  oled.print("GSR:");
  oled.print(value);
  
  oled.display();
  a++;
}
